package com.jiuqi.db;

import java.util.List;
import java.sql.SQLException;

public interface DBMetaData
{
    public static final int DBMS_UNKNOWN = 0;
    public static final int DBMS_SQLSERVER = 1;
    public static final int DBMS_ORACLE = 2;
    public static final int DBMS_DB2 = 3;
    public static final int DBMS_SYBASE = 4;
    public static final int DBMS_MYSQL = 5;
    
    int databaseType();
    
    int maxColumnCount();
    
    int maxRecordSize();
    
    int maxColumnByteSize(final int p0) throws SQLException;
    
    int maxIndexNameLength();
    
    int maxFieldNameLength();
    
    int maxTableNameLength();
    
    String getFieldDDL(final int p0, final int p1, final int p2, final boolean p3, final String p4) throws SQLException;
    
    String getDropFieldPreSql(final String p0, final String p1);
    
    String getDropFieldDDL(final String p0, final String p1);
    
    boolean getModifyFieldSqls(final String p0, final String p1, final int p2, final int p3, final int p4, final boolean p5, final String p6, final String p7, final int p8, final int p9, final int p10, final boolean p11, final String p12, final List p13) throws SQLException;
    
    boolean getDDLCausesTransactionCommit();
    
    boolean getDDLIgnoredInTransactions();
    
    String getDefaultScheme();
    
    boolean getSupportDropColumn();
    
    DBFunction createDBFunction();
    
    boolean getTruncateNumber();
}
